<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 2.13b (révision 29800)
#									########################
#					Développé pour Magento
#						Version : 1.3.2.2
#						Compatibilité plateforme : V1
#									########################
#					Développé par Lyra Network
#						http://www.lyra-network.com/
#						10/10/2011
#						Contact : support@payzen.eu
#
#####################################################################################################

class Mage_Vads_Model_PaymentMethod extends Mage_Payment_Model_Method_Abstract {
	// unique internal payment method identifier
	protected $_code = 'vads';

	// standard blocks to use
	protected $_formBlockType = 'vads/form';
	protected $_infoBlockType = 'vads/info';

	// Flags that determines payment method use cases

	//TODO verify exact signification of following parameters + change them if necessary

	// Is this payment method a gateway (online auth/charge) ?
	protected $_isGateway = true;

	// Does it need some action before processing ?
	// protected $_isInitializeNeeded      = true;

	// Can authorize online? => not implemented
	protected $_canAuthorize = true;

	// Can capture funds online? => not implemented
	protected $_canCapture = true;

	// Can capture partial amounts online?
	protected $_canCapturePartial = true;

	// Can refund online?
	protected $_canRefund = true;
	
	// Can refund parts of an order ?
    protected $_canRefundInvoicePartial     = true;

	// Can void transactions online? => yes but in PayZen backoffice
	protected $_canVoid = true;

	// Can use this payment method in administration panel?
	protected $_canUseInternal = true;

	// Can show this payment method as an option on checkout payment page?
	protected $_canUseCheckout = true;

	// Is this payment method suitable for multi-shipping checkout?
	protected $_canUseForMultishipping = true;

	// Can save credit card information for future processing?
	protected $_canSaveCc = false;
	
	// TODO Paramètres issus de paypal-magento 1.5.1.0, à analyser...
	// protected $_canOrder                    = true;
	// protected $_canFetchTransactionInfo     = true;
	// protected $_canCreateBillingAgreement   = true;
	// protected $_canReviewPayment        = true;

	/**
	 * Standard magento action ; used to set the order in "pending_payment" status
	 * @param string $paymentAction
	 * @param Varien_Object
	 */
	public function initialize($paymentAction, $stateObject) {
		// $state = Mage_Sales_Model_Order::STATE_PENDING_PAYMENT;
		// $stateObject->setState($state);
		// $stateObject->setStatus('pending_payment');
		// $stateObject->setIsNotified(false);
	}

	/**
	 *  The url the customer is redirected to after clicking on "Confirm order"
	 *
	 *  @return	  string Order Redirect URL
	 */
	public function getOrderPlaceRedirectUrl() {
		return Mage::getUrl('vads/standard/payment');
	}

	/**
	 * Refund money
	 *
	 * @param   Varien_Object $invoicePayment
	 * @return  Mage_Payment_Model_Abstract
	 */
	public function refund(Varien_Object $payment, $amount) {
		parent::refund($payment, $amount);
	}
}
?>